﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;

/// <summary>
/// Summary description for DataLayer
/// </summary>
public class DataLayer
{
    private enum SampleTables
    {
        Departments,
        Employees,
        Options
    }

    private DataTable GetSampleTable(SampleTables table)
    {
        DataTable retval;
        switch (table)
        {
            case SampleTables.Departments:
                retval = this.GetDepartments();
                break;
            case SampleTables.Employees:
                retval = this.GetEmployees();
                break;
            //case SampleTables.Options:
            //    retval = this.GetOptions();
            //    break;
            default:
                retval = this.GetDepartments();
                break;
        }
        return retval;
    }

    public DataSet GetEmployDepartmentDataSet()
    {
        DataSet dataset = new DataSet("EmployeeRecords");

        DataTable Employees = this.GetEmployees();
        DataTable Departments = this.GetDepartments();
      //  DataTable Options = this.GetOptions();

        dataset.Tables.Add(Departments);
        dataset.Tables.Add(Employees);
       // dataset.Tables.Add(Options);

        dataset.Relations.Add("DepartmentEmployee", Departments.Columns["DepartmentID"], Employees.Columns["Department"]);
       // dataset.Relations.Add("EmployeeOptions", Employees.Columns["EmployeeID"], Options.Columns["Employee"]);

        return dataset;
    }

    private DataTable GetDepartments()
    {
        DataTable datatable = new DataTable("Departments");

        datatable.Columns.Add("DepartmentID", typeof(int));
        datatable.Columns.Add("DepartmentName", typeof(string));


        for (int i = 0; i < 100; i++)
        {
            datatable.Rows.Add(new object[] { i, string.Format("Department {0}", i), });
        }
        datatable.PrimaryKey = new DataColumn[] { datatable.Columns["DepartmentID"] };
        return datatable;
    }

    private DataTable GetEmployees()
    {
        DataTable datatable = new DataTable("Employees");

        datatable.Columns.Add("EmployeeID", typeof(int));
        datatable.Columns.Add("EmployeeName", typeof(string));
        datatable.Columns.Add("Department", typeof(int));

        for (int i = 0; i < 30; i++)
        {           
            datatable.Rows.Add(new object[] { i, string.Format("EmployeeName {0}", i), 0 });
        }
        for (int i = 30; i < 60; i++)
        {
            datatable.Rows.Add(new object[] { i, string.Format("EmployeeName {0}", i), 1 });
        }
        for (int i = 60; i < 90; i++)
        {
            datatable.Rows.Add(new object[] { i, string.Format("EmployeeName {0}", i), 20 });
        }
        for (int i = 90; i < 120; i++)
        {
            datatable.Rows.Add(new object[] { i, string.Format("EmployeeName {0}", i), 60 });
        }
        datatable.PrimaryKey = new DataColumn[] { datatable.Columns["EmployeeID"] };
        return datatable;
    }

    public DataTable GetTableDropDown()
    {
        DataTable table = new DataTable("NumberOfPages");
        table.Columns.Add("PageNo", typeof(int));
        for (int i = 0; i < 100; i=i+10)
        {
            table.Rows.Add(i);
        }
        return table;
    }
    //private DataTable GetOptions()
    //{
    //    DataTable datatable = new DataTable("Options");

    //    datatable.Columns.Add("OptionID", typeof(int));
    //    datatable.Columns.Add("Employee", typeof(int));
    //    datatable.Columns.Add("Option", typeof(string));
    //    datatable.Columns.Add("Description", typeof(string));

    //    for (int i = 0; i < 30; i++)
    //    {
    //        datatable.Rows.Add(new object[] { i, i % 30, string.Format("Options {0}", 1), string.Format("Description {0}", i) });
    //    }
    //    datatable.PrimaryKey = new DataColumn[] { datatable.Columns["OptionsID"] };
    //    return datatable;
    //}
}